<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/__init__.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> IR, ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.DocString <span class="py-keyword">import</span> DocString</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.FileTree <span class="py-keyword">import</span> make_file_tree</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.TOC <span class="py-keyword">import</span> TOC</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.ClassTree <span class="py-keyword">import</span> ClassTree</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">from</span> DirectoryLayout <span class="py-keyword">import</span> *</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">from</span> XRefPager <span class="py-keyword">import</span> XRefPager</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">from</span> Views <span class="py-keyword">import</span> *</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">from</span> Frame <span class="py-keyword">import</span> Frame</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-keyword">from</span> FrameSet <span class="py-keyword">import</span> FrameSet</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Markup.Javadoc <span class="py-keyword">import</span> Javadoc</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-keyword">try</span>:</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-keyword">from</span> Synopsis.Formatters.HTML.Markup.RST <span class="py-keyword">import</span> RST</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-keyword">except</span> ImportError:</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">from</span> Synopsis.Formatters.HTML.Markup <span class="py-keyword">import</span> Formatter <span class="py-keyword">as</span> RST</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-keyword">import</span> Markup</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-keyword">import</span> Tags</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-keyword">import</span> time</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/DocCache.html">DocCache</a>:</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/DocCache.html#__init__">__init__</a>(self, processor, markup_formatters):</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        self._processor = processor</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        self._markup_formatters = markup_formatters</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-comment"># Make sure we have a default markup formatter.</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        <span class="py-keyword">if</span> <span class="py-string">''</span> <span class="py-keyword">not</span> <span class="py-keyword">in</span> self._markup_formatters:</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">            self._markup_formatters[<span class="py-string">''</span>] = Markup.Formatter()</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self._markup_formatters.values():</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">            f.init(self._processor)</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        self._doc_cache = {}</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/DocCache.html#_process">_process</a>(self, decl, view):</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the documentation for the given declaration.&quot;&quot;&quot;</span></span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        key = id(decl)</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        <span class="py-keyword">if</span> key <span class="py-keyword">not</span> <span class="py-keyword">in</span> self._doc_cache:</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            doc = decl.annotations.get(<span class="py-string">'doc'</span>)</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">            <span class="py-keyword">if</span> doc:</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">                formatter = self._markup_formatters.get(doc.markup,</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">                                                        self._markup_formatters[<span class="py-string">''</span>])</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                doc = formatter.format(decl, view)</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">                doc = Markup.Struct()</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">            <span class="py-comment"># FIXME: Unfortunately we can't easily cache these, as they may</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">            <span class="py-comment">#        contain relative URLs that aren't valid across views.</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">            <span class="py-comment"># self._doc_cache[key] = doc</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">            <span class="py-keyword">return</span> doc</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">            <span class="py-keyword">return</span> self._doc_cache[key]</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/DocCache.html#summary">summary</a>(self, decl, view):</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        doc = self._process(decl, view)</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">return</span> doc.summary</span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/DocCache.html#details">details</a>(self, decl, view):</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        doc = self._process(decl, view)</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">        <span class="py-keyword">return</span> doc.details</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/Formatter.html">Formatter</a>(Processor):</span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    title = Parameter(<span class="py-string">'Synopsis - Generated Documentation'</span>, <span class="py-string">'title to put into html header'</span>)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    stylesheet = Parameter(os.path.join(config.datadir, <span class="py-string">'html.css'</span>), <span class="py-string">'stylesheet to be used'</span>)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    directory_layout = Parameter(NestedDirectoryLayout(), <span class="py-string">'how to lay out the output files'</span>)</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    toc_in = Parameter([], <span class="py-string">'list of table of content files to use for symbol lookup'</span>)</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    toc_out = Parameter(<span class="py-string">''</span>, <span class="py-string">'name of file into which to store the TOC'</span>)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    sxr_prefix = Parameter(None, <span class="py-string">'path prefix (directory) under which to find sxr info'</span>)</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">    index = Parameter([ModuleTree(), FileTree()], <span class="py-string">'set of index views'</span>)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    detail = Parameter([ModuleIndex(), FileIndex()], <span class="py-string">'set of detail views'</span>)</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">    content = Parameter([Scope(),</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">                         Source(),</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                         XRef(),</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">                         FileDetails(),</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                         InheritanceTree(),</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                         InheritanceGraph(),</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">                         NameIndex()],</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">                        <span class="py-string">'set of content views'</span>)</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">    markup_formatters = Parameter({<span class="py-string">'javadoc'</span>:Javadoc(),</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                                   <span class="py-string">'rst'</span>:RST(),</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                                   <span class="py-string">'reStructuredText'</span>:RST()},</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                                  <span class="py-string">'Markup-specific formatters.'</span>)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    graph_color = Parameter(<span class="py-string">'#ffcc99'</span>, <span class="py-string">'base color for inheritance graphs'</span>)</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line108"></a><span class="lineno">108</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.output: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'output'</span>)</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        <span class="py-comment"># Make sure we operate on a single top-level node.</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-comment"># (Python package, C++ global namespace, etc.)</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-keyword">if</span> (len(self.ir.asg.declarations) != 1 <span class="py-keyword">or</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">            <span class="py-keyword">not</span> isinstance(self.ir.asg.declarations[0], ASG.Module)):</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            <span class="py-comment"># Assume this is C++ in this case.</span></span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            self.root = ASG.Module(None, -1, <span class="py-string">'namespace'</span>, QualifiedName())</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">            self.root.declarations = ir.asg.declarations</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">            self.root = self.ir.asg.declarations[0]</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        self.directory_layout.init(self)</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        self.documentation = DocCache(self, self.markup_formatters)</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        <span class="py-comment"># Create the class tree (shared by inheritance graph / tree views).</span></span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        self.class_tree = ClassTree()</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.root.declarations:</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">            d.accept(self.class_tree)</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        <span class="py-comment"># Create the file tree (shared by file listing / tree views).</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        self.file_tree = make_file_tree(self.ir.files.values())</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        <span class="py-comment"># Create the cross reference table (shared by XRef / Scope views)</span></span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        self.xref = XRefPager(self.ir)</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        <span class="py-keyword">from</span> Synopsis.DeclarationSorter <span class="py-keyword">import</span> DeclarationSorter</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">        self.sorter = DeclarationSorter()</span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-comment"># Make all views queryable through Formatter.has_view()</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        self.views = self.content + self.index + self.detail</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        frames = []</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">        <span class="py-comment"># If only content contains views don't use frames.</span></span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        <span class="py-keyword">if</span> self.index <span class="py-keyword">or</span> self.detail:</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">            Tags.using_frames = True</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            frames.append(Frame(self, self.index))</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            frames.append(Frame(self, self.detail))</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">            frames.append(Frame(self, self.content))</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">            Tags.using_frames = False</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">            frames.append(Frame(self, self.content, noframes = True))</span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">        self.__files = {} <span class="py-comment"># map from filename to (view,scope)</span></span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        <span class="py-comment"># The table of content is by definition the TOC of the first</span></span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        <span class="py-comment"># view on the content frame.</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        self.toc = self.content[0].toc()</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;TOC size:&quot;</span>, self.toc.size()</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        <span class="py-keyword">if</span> self.toc_out: self.toc.store(self.toc_out)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-comment"># load external references from toc files, if any</span></span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        <span class="py-keyword">for</span> t <span class="py-keyword">in</span> self.toc_in: self.toc.load(t)</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;HTML Formatter: Generating views...&quot;</span></span>
<a id="line167"></a><span class="lineno">167</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        <span class="py-comment"># Process the views.</span></span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        <span class="py-keyword">if</span> len(frames) &gt; 1:</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">            frameset = FrameSet()</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            frameset.process(self.output, self.directory_layout.index(),</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">                             self.title,</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">                             self.index[0].root()[0] <span class="py-keyword">or</span> self.index[0].filename(),</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">                             self.detail[0].root()[0] <span class="py-keyword">or</span> self.detail[0].filename(),</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">                             self.content[0].root()[0] <span class="py-keyword">or</span> self.content[0].filename())</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        <span class="py-keyword">for</span> frame <span class="py-keyword">in</span> frames: frame.process()</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line178"></a><span class="lineno">178</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/Formatter.html#has_view">has_view</a>(self, name):</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        <span class="py-string">&quot;&quot;&quot;test whether the given view is part of the views list.&quot;&quot;&quot;</span></span>
<a id="line181"></a><span class="lineno">181</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">        <span class="py-keyword">return</span> name <span class="py-keyword">in</span> [x.__class__.__name__ <span class="py-keyword">for</span> x <span class="py-keyword">in</span> self.views]</span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/Formatter.html#register_filename">register_filename</a>(self, filename, view, scope):</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Registers a file for later production. The first view to register</span></span>
<a id="line186"></a><span class="lineno">186</span><span class="line"><span class="py-string">        the filename gets to keep it.&quot;&quot;&quot;</span></span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        filename = str(filename)</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.__files.has_key(filename):</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">            self.__files[filename] = (view, scope)</span>
<a id="line191"></a><span class="lineno">191</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/HTML/Formatter.html#filename_info">filename_info</a>(self, filename):</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns information about a registered file, as a (view,scope)</span></span>
<a id="line194"></a><span class="lineno">194</span><span class="line"><span class="py-string">        pair. Will return None if the filename isn't registered.&quot;&quot;&quot;</span></span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        <span class="py-keyword">return</span> self.__files.get(filename)</span>
<a id="line197"></a><span class="lineno">197</span>
<a id="line198"></a><span class="lineno">198</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
